/*
	Name:Javascript M.Tabs Plugin
	Link:http://demo.webjyh.com/MTabs/
	Author:M.J
	Author URI: http://webjyh.com/
	Version: 1.0.2
*/
(function(){
	var MTabs = function( params ){
		if ( !params ) return false;
		if ( !params.currentClassName ) params.currentClassName = 'current';
		if ( !params.eventType ) params.eventType = 'mouseover';

		var _this = this;
		
		_this.navObj = document.getElementById( params.nav ).getElementsByTagName('ul')[0].getElementsByTagName('li');
		_this.contentObj = _this.getChildNodes( document.getElementById( params.content ) );
		_this.currentClassName = params.currentClassName; 
		_this.eventType = params.eventType;

		//初始化
		_this.reset( 'MTABS_CURRENT' );
		_this.current();
		_this.action();
	};
	MTabs.prototype = {
		action:function(){ //默认切换功能
			var _this = this;
			for ( var i=0; i<_this.navObj.length; i++ ){ //绑定触发事件
				_this.navObj[i].eq = i; //将当前元素第几个存入对象中
				if ( _this.eventType == 'click' ){ //判断触发事件 两种类型，点击和滑过
					_this.navObj[i].onclick = function(){
						_this.reset( 'MTABS_ALL' ); //将所有的Tab重置
						_this.setClassName( _this.navObj[this.eq].getElementsByTagName('a')[0], _this.currentClassName ); //给当前的触发的添加ClassName
						_this.setStyle( _this.contentObj[this.eq], 'block' ); //给当前触发对应的内容显示
					}
				} else { //滑过的事件
					_this.navObj[i].onmouseover = function(){
						_this.reset( 'MTABS_ALL' );
						_this.setClassName( _this.navObj[this.eq].getElementsByTagName('a')[0], _this.currentClassName );
						_this.setStyle( _this.contentObj[this.eq], 'block' );
					}
				}
			}
		},
		reset:function( type ){		//将Tab全部默认还原
			var _this = this;
			for ( var j=0; j<_this.contentObj.length; j++ ){
				if ( type == 'MTABS_ALL' ){
					_this.setClassName( _this.navObj[j].getElementsByTagName('a')[0], 'MTABS_RESET' );
				}
				_this.setStyle( _this.contentObj[j], 'none' );
			}
		},
		setStyle:function( obj, val ){		//设置CSS
			return obj.style.display = val;
		},
		setClassName:function( obj, val ){	//设置class
			var c = obj.className,
				_this = this;
				c = _this.trim( c.replace( _this.currentClassName, '' ) );
			if ( val != '' && val != 'MTABS_RESET' ){
				return obj.className = c+' '+val;
			} else {
				return obj.className = c;
			}
			
		},
		getChildNodes:function( obj ){
			var c = obj.childNodes,
				a = [];
			if ( c ){
				for ( var i=0; i<c.length; i++ ){
					if ( c[i].nodeType == 1 ){
						a.push( c[i] );
					}
				}
				return a;
			} else {
				return false;
			}
		},
		trim:function( str ){
			return str.replace(/(^\s*)|(\s*$)/g, ""); 
		},
		current:function(){
			var _this = this,
				n = 0;
			for ( var i=0; i<_this.navObj.length; i++ ){
				var c = _this.navObj[i].getElementsByTagName('a')[0].className;
				if ( c.indexOf( _this.currentClassName ) >= 0 ){
					_this.setStyle( _this.contentObj[i], 'block' );
					n++;
					break;
				}
			}
			if ( n == 0 ){
				_this.setClassName( _this.navObj[0].getElementsByTagName('a')[0], _this.currentClassName );
				_this.setStyle( _this.contentObj[0], 'block' ); //设置内容第一个元素默认显示
			}
		}
	};
	window.MTabs = MTabs;		//绑定对象
}());